#include <hmg.ch>
#include 'hbclass.ch'

/*
	 1   2	 3
	 4 	 5	 6
	 7 	 8	 9
	10  11  12
	
*/

#DEFINE _FILAS 6
#DEFINE _COLUMNAS 6
#DEFINE _PAUSA 500000

Function Main
    Local oJuego:= Principal():iniciar()
    oJuego:activar()
    oJuego:Revolver()
    
Return nil

Class Principal
	Data aColores
	Data aClick
	Data aPosiciones
	Data aControles
	Data Puntaje
	Data aPares
	Data cPath
	Data nEliminados 
	Method iniciar() constructor
	Method activar()
	Method generar_controles()
	Method revolver()
	Method etiqueta_click(nitem)
	Method verifica_pares()
	Method cadena_color( aColor )	inline aColor
	Method numero_aleatorio()
	Method verifica_coincidencias()
	Method Repintar()
	Method pausa()
	Method Actualiza_puntaje()
	Method traspaso( a, b )
	Method obtener_posicion( cid ) 
	Method cambiar_tema()	
	Method crea_control( cnombre, nrow, ncol, cColor )

	*Method obtener_id_celda(nid)
	
End class

Method iniciar() class principal
	::cPath			:= 'africa'
	::aColores		:= { ::cpath + '/item1.png',::cpath + '/item2.png',::cpath + '/item3.png',::cpath + '/item4.png',::cpath + '/item5.png'}
	::aClick		:= {0,0}
	::aPosiciones	:= {}
	::aControles	:= {}
	::Puntaje		:= 0
	::aPares		:= {}
	::nEliminados	:= 0
Return Self

Method activar class principal
	local aitems :={'Africa','Criaturas','Cristal','Nuvola','Toys'}
	Load Window Main
	Main.Center
	Main.Activate
	
Return nil

Method generar_controles class principal
	local r := 1, nrow:= 40, ncol := 10
	local cControl := ""
	local atemp := {}
	::aPosiciones := {}
	main.player_1.visible := .f.
	main.player_2.visible := .f.
	for i= 1 to _FILAS
		do events
		atemp := {}
		for j = 1 to _COLUMNAS
			do events
			cControl := 'LABEL_'+alltrim(str(r))
			define image &cControl
				parent 	main
				row 	nrow
				col 	ncol
				width 	50
				height 	50
				picture	""
				on click ::etiqueta_click(this.name)
				stretch .t.
			end image
			aadd( atemp, cControl )
			ncol += 60
			r ++		
		next
		aadd( ::aPosiciones, atemp )
		
		nrow += 60
		nCol =  10
	next
Return

Method numero_aleatorio() class principal
	local nNumero := 0
	nNumero := round(HB_RANDOM(1,len(::aColores)),0)
	if nNumero < 1 .or. nNumero > len(::aColores )
		nNumero = 1
	Endif                              	
Return nNumero

Method crea_control( nId, nrow, ncol, npos ) class principal
	local oCelda
	oCelda			:= Celda():Nuevo()
	oCelda:Nombre	:= 'LABEL_'+alltrim(str(nid))
	oCelda:Color    := ::aColores[ ::numero_aleatorio ]
	oCelda:Fila     := nrow
	oCelda:Columna	:= ncol
	oCelda:Eliminar	:= .f.
	oCelda:id		:= npos
	oCelda:cColor	:= oCelda:Color
	oCelda:Pintar()	
return oCelda
 
Method revolver class principal
	local i := 0, nRandom := 0, r := 1, f := 0, c := 0
	local oCelda

	if len( ::aControles ) > 0
		for i= 1 to len( ::aControles )
			do events
			::aControles[i]:Finalizar()
		Next
	endif
	
	::aControles := {}
	Main.width	:= ( 60 * _COLUMNAS	) + 20
	Main.height	:= ( 60 * _FILAS ) + 120
	
	for i := 1 to  _FILAS 
		do events
		
		for c = 1 to _COLUMNAS		
			do events
		
			nRandom			:= ::numero_aleatorio()
			oCelda			:= ::crea_control( r, i, c, r )
			oCelda:Pintar()
			aadd( ::aControles, oCelda )

			r ++

		next
		
	Next
		
	::aClick	:={0,0}
	::Puntaje	:= 0
	::actualiza_puntaje()
	if ::verifica_coincidencias()
		::Repintar()
	Endif
return
      
Method obtener_posicion( cId ) class principal
	local i := 1, npos := 0
	
	for i= 1 to len( ::aControles )
		do events
		if ::aControles[i]:Nombre = cId
			nPos = i
			exit
		endif
	Next
	
return npos

method etiqueta_click( cItem ) class principal
	local aposibilidades:= {}, apos:= {0,0,0,0}
	local lMover := .f.                    
	local cColor
	local Control1, Control2
	local nombre, fila, columna, id, i
	
	
	If pcount() > 0 
		nItem	= ::obtener_posicion( cItem )
	Endif
	
	* 1= origen
	* 2= destino

	If ::aclick[1] = 0
		::aclick[1] = nItem
		Return
	Endif
	
	If ::aclick[2] = 0
		::aclick[2] = nitem
	Endif	
	
	* si son iguales se vacia.
	If ::aclick[1] = ::aclick[2] 
		::aclick = { 0, 0 }
		Return
	Endif
		
	Control1	= ::aControles[ ::aClick[1] ]
	Control2	= ::aControles[ ::aClick[2] ]
	
	* generar las posibilidades
	aposibilidades := {}
	
	* arriba
	if Control1:Fila - 1 >= 1
		aadd( aposibilidades, { Control1:Fila-1, Control1:Columna } )
	endif
	
	* derecha
	if Control1:Columna+1 <= _COLUMNAS
		aadd( aposibilidades, { Control1:Fila, Control1:Columna+1 } )
	endif
	
	*abajo
	if Control1:Fila+1 <= _FILAS
		aadd( aposibilidades, { Control1:Fila+1, Control1:Columna } )
	endif
	
	* izquierda
	if Control1:Columna-1 > 0
		aadd( aposibilidades, { Control1:Fila, Control1:Columna-1 } )
	endif
	
	* genera array de posibilidades
	For i := 1 to len( aposibilidades )
		do Events
		If aposibilidades[i][1] = Control2:Fila .and. aposibilidades[i][2] = Control2:Columna
			lMover := .t.
			Exit
		Endif
	Next
		
	If lMover

			* cambio los colores de las celdas.
			::Traspaso( ::aClick[1], ::aClick[2] )
			
			if ::verifica_coincidencias()	    					
				::Repintar()		
			else
				::traspaso( ::aClick[1], ::aClick[2] )
				msgstop('No')
			endif
	else
		msgstop('No')
			
	endif
	
	::aclick := {0,0}

return

Method traspaso( a, b ) class principal
	Local xColor	:= ::aControles[a]:Color, 	xcColor	:= ::aControles[a]:cColor
	
	::aControles[a]:Color	:= ::aControles[b]:Color
	::aControles[a]:cColor	:= ::aControles[b]:cColor
	::aControles[a]:Pintar()
	::pausa()
	
	::aControles[b]:Color	:= xColor
	::aControles[b]:cColor	:= xcColor
	::aControles[b]:Pintar()
	::pausa()
	
return nil

method verifica_coincidencias() class principal
	local aFila := {}, atemp :={}
	local lCoincidencias := .f.
	local id
	local i := 0, j := 0, k := 0, r := 0, o :=0, p := 0, ncontador := 0, f, c
	local Control1, Control2
	
	main.statusbar.item(1) := 'Calculando ...'
	
	* Genero el arreglo de filas y columnas
    r = 1
	For i := 1 to _FILAS
		do Events
		atemp = {}
		for j = 1 to _COLUMNAS
			do events
			aadd( atemp, ::acontroles[r] )
			r ++
		next
		aadd( aFila, atemp)
	Next
	
	* 1o verifico las filas
	
	For i := 1 to _FILAS
		do Events
		
		For j := 1 to _COLUMNAS 
			do Events
			
			atemp		:= {}
			Control1 	:= aFila[i][j]
			
			If Control1:cColor != "255255255"
				k := j
				Do While  k <= _COLUMNAS
					do events
					Control2 := aFila[i][k]
					if !Control2:Eliminar
					if Control1:cColor == Control2:cColor
				 		aadd( atemp, Control2:nombre )
				 	else
				 		k = _COLUMNAS
				 	endif				 		
				 	endif
				 	k ++
				Enddo
				
			Endif
			
			if len( atemp ) >= 3
				lCoincidencias := .t.
				for k := 1 to len( atemp )
					do events
					r = ::obtener_posicion( atemp[ k ] )
					if r > 0
						::aControles[ r ]:Eliminar 	:= .T.						
						*::aControles[ r ]:Color := 'sistema\icon.png'
						*::aControles[ r ]:Pintar()
						ncontador ++
					Endif
				next				
			Endif			
		next			
	next
	
	
	* Verifico columnas
	atemp = {}
	
	For i= 1 to _COLUMNAS
		do events
		atemp :={}
		
		For j := 1 to _FILAS
			do events
			atemp 	:= {}
			Control1:= aFila[j,i]
			if Control1:cColor != "255255255"
				k := j
				while k <= _FILAS					
					do events
					
					Control2 = aFila[k,i]
					if !Control2:Eliminar
					if Control1:cColor = Control2:cColor
						aadd( atemp, Control2:nombre )	
					Else
						k = _FILAS
					endif
					endif
					k ++
				enddo				
			endif
			
			if len( atemp ) >= 3
				lCoincidencias := .t.
				For k= 1 to len( atemp )
					Do Events
					r = ::obtener_posicion( atemp[ k ] )
					if r > 0
						::aControles[ r ]:Eliminar 	:= .T.
						*::aControles[ r ]:Color := 'sistema\icon.png'
						*::aControles[ r ]:Pintar()
						ncontador ++
					Endif
				Next
			Endif
		next		
	next	
	
	* Muestra el disparo.
	
	for i= 1 to len( ::aControles )
		do events
		if ::aControles[i]:Eliminar
			atemp ={'sistema\particle3.png','sistema\particle2.png','sistema\particle1.png','sistema\icon.png'}
			setproperty('main','player_1','file', 'sistema\sfx1.wav')
			for r = 1 to len( atemp )
				do events
				main.player_1.play()
				::aControles[ i ]:Color		:= atemp[r]
				::aControles[ i ]:cColor	:= atemp[r]
				::aControles[ i ]:Pintar()
				::pausa()
				main.player_1.resume()								
			next				

		endif
	next
	
	* bajo objetos no eliminados por columnas
	* 1 Elimino los muertos
	* 2 Redimensiono el array
	* 3 Agrego los nuevos objetos al principio del arreglo
	* 4 Restablesco los nombres, la fila y columna de cada control
	* 5 Repinto la pantalla
	
	* Cuento muertos
	*+p = 0
	*+atemp := {}	
	*+if ncontador > 0
	*+	For i= 1 to len( ::aControles )
	*+		do events
	*+		if ! ::aControles[i]:Eliminar
	*+			aadd( atemp, ::aControles[i] )
	*+		endif
	*+	Next
	*+	
	*+	p = Len( ::aControles ) - Len( aTemp )
	*+	* Redimensiono el array	
	*+	::aControles := aTemp		
    *+	::nEliminados = p
	*+	aTemp = {}
	*+	
	*+	* Agrego los nuevos objetos
    *+
	*+	For i= 1 to p
	*+		do events
	*+		o := ::crea_control(i, 0, 0, i )
	*+		o:Eliminar 	:= .T.
	*+		o:Color		:= 'sistema\icon.png'
	*+		aadd( atemp, o )
	*+	Next
	*+	
	*+	for i= 1 to len( ::aControles )
	*+		do events
	*+		aadd( atemp, ::aControles[i] )
	*+	Next
	*+	
	*+	::aControles := aTemp
	*+	
	*+	* Reestablezco los nombres
	*+	c = _COLUMNAS
	*+	f = _FILAS
	*+	for i := len( ::aControles ) to 1 step -1
	*+		do events
	*+		
	*+		::aControles[i]:nombre 	= 'LABEL_'+alltrim(str(i))
	*+		::aControles[i]:fila	= f
	*+		::aControles[i]:Columna	= c
	*+		::aControles[i]:id		= i
	*+		::aControles[i]:Pintar()
	*+		::pausa()
	*+		c --
	*+		if c < 1
	*+			f --
	*+			c = _COLUMNAS
	*+		endif
	*+	next
	*+
	*+endif
	
return lCoincidencias

Method Repintar class principal
	local i, j, id
	local nMuertos := 0
	setproperty('main','player_2','file', 'sistema\sfx2.wav')
	
	** rellena
	
	*main.player_2.play()
	for i= 1 to Len(::aControles)
		do events
		if ::aControles[i]:Eliminar
			::aControles[i]:Color	:= ::aColores[ ::numero_aleatorio() ]
			::aControles[i]:cColor	:= ::cadena_color( ::aControles[i]:Color )
			::aControles[i]:Eliminar:= .f.
			::aControles[i]:Pintar()
			::Puntaje+= 100
			::Actualiza_puntaje()
			::pausa()
		endif
	Next
	*main.player_2.resume()

	if ::verifica_coincidencias()
		::Repintar()
	endif
	main.statusbar.item(1) := 'Listo'

return

Method pausa class principal
	local nTiempo:=0
	while ( ++nTiempo <= _PAUSA ); end
return nil

Method actualiza_puntaje class principal
	main.label_puntaje.value := 'Puntaje : ' + transform( ::Puntaje,'999,999,999' )
return

Method verifica_pares() class principal
	
return nil

Method cambiar_tema() class principal
	local i := 1, hasta := 5
	local cfile:=""
	::cpath	:= main.combo_1.item( main.combo_1.value )
	Hasta = if( main.combo_1.value = 1, 5, 6 )
	::aColores := {}
	for i= 1 to hasta
		cfile = 'item'+alltrim(str(i))
		aadd( ::aColores, ::cPath + '\'+cFile+'.png')
	Next
		
	::revolver() 
return nil

Class Celda
	Data Nombre
	Data Color
	Data Fila
	Data Columna
	Data Eliminar
	Data id
	Data cColor
	
	Method Nuevo() Constructor
	Method Finalizar()
	Method pintar()		inline setProperty('main', ::Nombre, 'picture', ::Color )
	Method pintarid()	inline setProperty('main', ::Nombre, 'value', hb_valtostr( ::id ) )
End class

Method Nuevo() class celda
	::nombre	:= ""
	::Color		:= {}
	::fila		:= 0
	::columna	:= 0
	::Eliminar	:= .f.
	::id		:= 0
	::cColor	:= ""
Return Self

Method Finalizar() Class Celda
	::nombre	:= nil
	::Color		:= nil
	::fila		:= nil
	::columna	:= nil
	::Eliminar	:= nil
	::id		:= nil
	::cColor	:= nil
Return nil
