#include <hmg.ch>
#include 'hbclass.ch'

/*
	1	2	3
	4	5	6
	7	8	9
	
*/

#DEFINE _FILAS 3
#DEFINE _COLUMNAS 3
#DEFINE _PAUSA 5000000

Function Main
    Local oJuego:= Principal():iniciar()
    oJuego:activar()
    oJuego:Revolver()
    
Return nil

Class Principal
	Data aColores
	Data aClick
	Data aPosiciones
	Data aControles
	Data Puntaje
	Data aPares

	Method iniciar() constructor
	Method activar()
	Method revolver()
	Method etiqueta_click(nitem)
	Method verifica_pares()
	Method cadena_color( aColor )	inline alltrim(str( aColor[1],0 ))+alltrim(str(aColor[2],0))+alltrim(str(aColor[3],0))
	Method numero_aleatorio()
	Method verifica_coincidencias()
	Method Repintar()
	Method pausa()
	Method Actualiza_puntaje() 

	*Method obtener_id_celda(nid)
	
End class

Method iniciar() class principal
	::aColores		:= {{255,0,0},{0,255,0},{0,0,255},{255,0,255},{0,255,255},{255,255,0},;
						{200,0,0},{0,200,0}}
	::aClick		:= {0,0}
	::aPosiciones	:= {{1,2,3},{4,5,6},{7,8,9}}
	::aControles	:= {}
	::Puntaje		:= 0
	::aPares		:= {}
Return Self

Method activar class principal

	Load Window Main
	Main.Center
	Main.Activate
	
Return nil

Method numero_aleatorio() class principal
	local nNumero := 0
	nNumero := round(HB_RANDOM(1,len(::aColores)),0)
	if nNumero < 1 .or. nNumero > len(::aColores )
		nNumero = 1
	Endif                              
	
Return nNumero

Method revolver class principal
	local i := 0, nRandom := 0, r := 1, f := 0, c := 0
	local oCelda
	if len( ::aControles ) > 0
		for i= 1 to len( ::aControles )
			::aControles[1]:Finalizar()
		Next
	endif
	::aControles := {}
	for i= 1 to  _FILAS 
		
		for c = 1 to _COLUMNAS		
		
			nRandom	:= ::numero_aleatorio()
		
			oCelda			:= Celda():Nuevo()
			oCelda:Nombre	:= 'LABEL_'+alltrim(str(r))
			oCelda:Color    := ::aColores[ nRandom ]
			oCelda:Fila     := i
			oCelda:Columna	:= c
			oCelda:Eliminar	:= .f.
			oCelda:id		:= r
			oCelda:cColor	:= ::Cadena_Color( oCelda:Color )
			oCelda:Pintar()
			aadd( ::aControles, oCelda )
			r ++
			
		next
		
	Next
		
	::aClick	:={0,0}
	::Puntaje	:= 0
	::actualiza_puntaje()
	if ::verifica_coincidencias()
		::Repintar()
	Endif
return

method etiqueta_click( nItem ) class principal
	local aposibilidades:= {}, apos:= {0,0,0,0}
	local lMover := .f.                    
	local cColor
	local Control1, Control2
	local nombre, fila, columna, id, i
	
	* 1= origen
	* 2= destino
	
	if ::aclick[1] = 0
		::aclick[1] = nItem
		return
	endif
	
	if ::aclick[2] = 0
		::aclick[2] = nitem
	endif
	
	* verifica movimientos
	
	* si son iguales se vacia.
	if ::aclick[1] = ::aclick[2] 
		::aclick = { 0, 0 }
		return
	endif
		
	Control1	= ::aControles[ ::aClick[1] ]
	Control2	= ::aControles[ ::aClick[2] ]
	* generar las posibilidades
	aposibilidades := {}
	
	* arriba

	if Control1:Fila - 1 >= 1
		aadd( aposibilidades, { Control1:Fila-1, Control1:Columna } )
	endif
	
	* derecha

	if Control1:Columna+1 <= _COLUMNAS
		aadd( aposibilidades, { Control1:Fila, Control1:Columna+1 } )
	endif
	
	*abajo

	if Control1:Fila+1 <= _FILAS
		aadd( aposibilidades, { Control1:Fila+1, Control1:Columna } )
	endif
	
	* izquierda
	if Control1:Columna-1 > 0
		aadd( aposibilidades, { Control1:Fila, Control1:Columna-1 } )
	endif
	
	* genera array de posibilidades
	for i= 1 to len( aposibilidades )
		if aposibilidades[i][1] = Control2:Fila .and. aposibilidades[i][2] = Control2:Columna
			lMover := .t.
			exit
		endif
	next
	
		
	
	if lMover
		
			* cambio los colores de las celdas.
			
			Control1 = ::aControles[ ::aClick[1] ]
			Control2 = ::aControles[ ::aClick[2] ]
			fila	= Control1:fila
			columna	= Control1:columna
			id		= Control1:id
			nombre	= Control1:nombre
			
			Control1:nombre	= Control2:nombre
			Control1:fila	= Control2:fila
			Control1:columna= Control2:columna
			Control1:id		= Control2:id
			
			Control2:nombre	= nombre
			Control2:fila	= fila
			Control2:columna= columna
			Control2:id		= id
        	
			::aControles[::aClick[1] ] := Control2
			::aControles[::aClick[2] ] := Control1
			::aControles[::aClick[1] ]:Pintar()
			::aControles[::aClick[2] ]:Pintar()
			
			if ::verifica_coincidencias()	    	
				::Repintar()		
			else
				Control1 = ::aControles[ ::aClick[1] ]
				Control2 = ::aControles[ ::aClick[2] ]
				fila	= Control1:fila
				columna	= Control1:columna
				id		= Control1:id
				nombre	= Control1:nombre
				
				Control1:nombre	= Control2:nombre
				Control1:fila	= Control2:fila
				Control1:columna= Control2:columna
				Control1:id		= Control2:id
				
				Control2:nombre	= nombre
				Control2:fila	= fila
				Control2:columna= columna
				Control2:id		= id
        		
				::aControles[::aClick[1] ] := Control2
				::aControles[::aClick[2] ] := Control1
				::aControles[::aClick[1] ]:Pintar()
				::aControles[::aClick[2] ]:Pintar()
				msgstop('Movimiento no permitido')
			endif
			
	endif
	
	::aclick := {0,0}

return

method verifica_coincidencias() class principal
	local aFila := Array( _FILAS )
	local lCoincidencias := .f.
	local f , c , id1, id2
	
    ::aPares :={}
	main.statusbar.item(1) := 'Calculando ...'
	
	for i= 1 to _FILAS
		aFila[i] = {} 
	Next

	for i= 1 to len( ::aControles )
		aadd( aFila[ ::aControles[i]:Fila ], ::aControles[i]:id )
	Next
	* 1o verifico las filas
	for i= 1 to _FILAS
		for j= 1 to _COLUMNAS -1
			id1 = aFila[i][j] 
			id2 = aFila[i][j+1]
			if ! ::aControles[ id1 ]:Eliminar
				if ::aControles[ id1 ]:cColor = ::aControles[ id2 ]:cColor
					::aControles[ id1 ]:Eliminar 	:= .T.
					::aControles[ id2 ]:Eliminar 	:= .T.
					lCoincidencias := .t.
					aadd( ::aPares, { id1, id2 } )
				endif
			endif
		next
	next
	
	* Verifico columnas
	
	for i= 1 to _COLUMNAS
		for j= 1 to _FILAS -1
			id1 = aFila[j][i] 
			id2 = aFila[j+1][i]
			if ! ::aControles[ id1 ]:Eliminar
				if ::aControles[ id1 ]:cColor = ::aControles[ id2 ]:cColor
					::aControles[ id1 ]:Eliminar 	:= .T.
					::aControles[ id2 ]:Eliminar 	:= .T.
					::aControles[ id1 ]:Color		:= {255,255,255}
					::aControles[ id2 ]:Color		:= {255,255,255}
					::aControles[ id1 ]:Pintar()
					::aControles[ id2 ]:Pintar()
					::pausa()
					lCoincidencias := .t.
					aadd( ::aPares, { id1, id2 } )
				endif
			endif
		next
	next
	
		
return lCoincidencias

Method Repintar class principal
	local i, j, id
	
	for i= 1 to len( ::aControles )
		if ::aControles[i]:Eliminar
			::aControles[i]:Color	:= ::aColores[ ::numero_aleatorio() ]
			::aControles[i]:cColor	:= ::cadena_color( ::aControles[i]:Color )
			::aControles[i]:Eliminar:= .f.
			::aControles[i]:Pintar()
			::Puntaje+= 100
			::Actualiza_puntaje()
			::pausa()
		endif
	Next

	if ::verifica_coincidencias()
		::Repintar()
	endif
	main.statusbar.item(1) := 'Listo'

return

Method pausa class principal
	local nTiempo:=0
	while ( ++nTiempo <= _PAUSA ); end
return nil

Method actualiza_puntaje class principal
	main.label_11.value := 'Puntaje : ' + transform( ::Puntaje,'999,999,999' )
return

Method verifica_pares() class principal
	
return nil

Class Celda
	Data Nombre
	Data Color
	Data Fila
	Data Columna
	Data Eliminar
	Data id
	Data cColor
	
	Method Nuevo() Constructor
	Method Finalizar()
	Method pintar()	inline setProperty('main', ::Nombre, 'backcolor', ::Color )
End class

Method Nuevo() class celda
	::nombre	:= ""
	::Color		:= {}
	::fila		:= 0
	::columna	:= 0
	::Eliminar	:= .f.
	::id		:= 0
	::cColor	:= ""
Return Self

Method Finalizar() Class Celda
	::nombre 	:=nil
	::color	:= nil
	::fila		:= nil
	::columna	:= nil
Return nil
